<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>ImmutableHierarchicalConfiguration (Apache Commons Configuration 2.2 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="ImmutableHierarchicalConfiguration (Apache Commons Configuration 2.2 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":6,"i1":6,"i2":6,"i3":6,"i4":6,"i5":6,"i6":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/ImmutableHierarchicalConfiguration.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html" title="interface in org.apache.commons.configuration2"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/apache/commons/configuration2/INIConfiguration.html" title="class in org.apache.commons.configuration2"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html" target="_top">Frames</a></li>
<li><a href="ImmutableHierarchicalConfiguration.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.configuration2</div>
<h2 title="Interface ImmutableHierarchicalConfiguration" class="title">Interface ImmutableHierarchicalConfiguration</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Superinterfaces:</dt>
<dd><a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableConfiguration</a></dd>
</dl>
<dl>
<dt>All Known Subinterfaces:</dt>
<dd><a href="../../../../org/apache/commons/configuration2/HierarchicalConfiguration.html" title="interface in org.apache.commons.configuration2">HierarchicalConfiguration</a>&lt;T&gt;</dd>
</dl>
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><a href="../../../../org/apache/commons/configuration2/AbstractHierarchicalConfiguration.html" title="class in org.apache.commons.configuration2">AbstractHierarchicalConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/AbstractYAMLBasedConfiguration.html" title="class in org.apache.commons.configuration2">AbstractYAMLBasedConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/BaseHierarchicalConfiguration.html" title="class in org.apache.commons.configuration2">BaseHierarchicalConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/CombinedConfiguration.html" title="class in org.apache.commons.configuration2">CombinedConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/DynamicCombinedConfiguration.html" title="class in org.apache.commons.configuration2">DynamicCombinedConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/INIConfiguration.html" title="class in org.apache.commons.configuration2">INIConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/JSONConfiguration.html" title="class in org.apache.commons.configuration2">JSONConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/PatternSubtreeConfigurationWrapper.html" title="class in org.apache.commons.configuration2">PatternSubtreeConfigurationWrapper</a>, <a href="../../../../org/apache/commons/configuration2/plist/PropertyListConfiguration.html" title="class in org.apache.commons.configuration2.plist">PropertyListConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/SubnodeConfiguration.html" title="class in org.apache.commons.configuration2">SubnodeConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/XMLConfiguration.html" title="class in org.apache.commons.configuration2">XMLConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/plist/XMLPropertyListConfiguration.html" title="class in org.apache.commons.configuration2.plist">XMLPropertyListConfiguration</a>, <a href="../../../../org/apache/commons/configuration2/YAMLConfiguration.html" title="class in org.apache.commons.configuration2">YAMLConfiguration</a></dd>
</dl>
<hr>
<br>
<pre>public interface <span class="typeNameLabel">ImmutableHierarchicalConfiguration</span>
extends <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableConfiguration</a></pre>
<div class="block"><p>
 An interface for immutable hierarchical configurations.
 </p>
 <p>
 There are some sources of configuration data that cannot be stored very well
 in a flat configuration object (like <a href="../../../../org/apache/commons/configuration2/BaseConfiguration.html" title="class in org.apache.commons.configuration2"><code>BaseConfiguration</code></a>) because then
 their structure is lost. A prominent example are XML documents.
 </p>
 <p>
 This interface extends the basic <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html" title="interface in org.apache.commons.configuration2"><code>ImmutableConfiguration</code></a> interface by
 structured access to configuration properties. An <a href="../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree"><code>ExpressionEngine</code></a> is
 used to evaluate complex property keys and to map them to nodes of a
 tree-like structure.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>2.0</dd>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>$Id: ImmutableHierarchicalConfiguration.java 1679758 2015-05-16 17:35:56Z oheger $</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html#getExpressionEngine--">getExpressionEngine</a></span>()</code>
<div class="block">Returns the expression engine used by this configuration.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html#getMaxIndex-java.lang.String-">getMaxIndex</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key)</code>
<div class="block">Returns the maximum defined index for the given key.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html#getRootElementName--">getRootElementName</a></span>()</code>
<div class="block">Returns the name of the root element of this configuration.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableHierarchicalConfiguration</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html#immutableChildConfigurationsAt-java.lang.String-">immutableChildConfigurationsAt</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key)</code>
<div class="block">Returns a list of immutable configurations for all direct child elements
 of the node selected by the given key.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableHierarchicalConfiguration</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html#immutableConfigurationAt-java.lang.String-">immutableConfigurationAt</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key)</code>
<div class="block">Returns an immutable hierarchical configuration for the node specified by
 the given key.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableHierarchicalConfiguration</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html#immutableConfigurationAt-java.lang.String-boolean-">immutableConfigurationAt</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                        boolean&nbsp;supportUpdates)</code>
<div class="block">
 Returns an immutable hierarchical configuration object that wraps the
 configuration node specified by the given key.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableHierarchicalConfiguration</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html#immutableConfigurationsAt-java.lang.String-">immutableConfigurationsAt</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key)</code>
<div class="block">Returns a list of immutable configurations for all configuration nodes selected
 by the given key.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.apache.commons.configuration2.ImmutableConfiguration">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.apache.commons.configuration2.<a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableConfiguration</a></h3>
<code><a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#containsKey-java.lang.String-">containsKey</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#get-java.lang.Class-java.lang.String-">get</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#get-java.lang.Class-java.lang.String-T-">get</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getArray-java.lang.Class-java.lang.String-">getArray</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getArray-java.lang.Class-java.lang.String-java.lang.Object-">getArray</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getBigDecimal-java.lang.String-">getBigDecimal</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getBigDecimal-java.lang.String-java.math.BigDecimal-">getBigDecimal</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getBigInteger-java.lang.String-">getBigInteger</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getBigInteger-java.lang.String-java.math.BigInteger-">getBigInteger</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getBoolean-java.lang.String-">getBoolean</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getBoolean-java.lang.String-boolean-">getBoolean</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getBoolean-java.lang.String-java.lang.Boolean-">getBoolean</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getByte-java.lang.String-">getByte</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getByte-java.lang.String-byte-">getByte</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getByte-java.lang.String-java.lang.Byte-">getByte</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getCollection-java.lang.Class-java.lang.String-java.util.Collection-">getCollection</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getCollection-java.lang.Class-java.lang.String-java.util.Collection-java.util.Collection-">getCollection</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getDouble-java.lang.String-">getDouble</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getDouble-java.lang.String-double-">getDouble</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getDouble-java.lang.String-java.lang.Double-">getDouble</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getEncodedString-java.lang.String-">getEncodedString</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getEncodedString-java.lang.String-org.apache.commons.configuration2.ConfigurationDecoder-">getEncodedString</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getFloat-java.lang.String-">getFloat</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getFloat-java.lang.String-float-">getFloat</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getFloat-java.lang.String-java.lang.Float-">getFloat</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getInt-java.lang.String-">getInt</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getInt-java.lang.String-int-">getInt</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getInteger-java.lang.String-java.lang.Integer-">getInteger</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getKeys--">getKeys</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getKeys-java.lang.String-">getKeys</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getList-java.lang.Class-java.lang.String-">getList</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getList-java.lang.Class-java.lang.String-java.util.List-">getList</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getList-java.lang.String-">getList</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getList-java.lang.String-java.util.List-">getList</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getLong-java.lang.String-">getLong</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getLong-java.lang.String-long-">getLong</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getLong-java.lang.String-java.lang.Long-">getLong</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getProperties-java.lang.String-">getProperties</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getProperty-java.lang.String-">getProperty</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getShort-java.lang.String-">getShort</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getShort-java.lang.String-short-">getShort</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getShort-java.lang.String-java.lang.Short-">getShort</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getString-java.lang.String-">getString</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getString-java.lang.String-java.lang.String-">getString</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getStringArray-java.lang.String-">getStringArray</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#immutableSubset-java.lang.String-">immutableSubset</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#isEmpty--">isEmpty</a>, <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#size--">size</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getExpressionEngine--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExpressionEngine</h4>
<pre><a href="../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a>&nbsp;getExpressionEngine()</pre>
<div class="block">Returns the expression engine used by this configuration. This method
 will never return <b>null</b>; if no specific expression engine was set,
 the default expression engine will be returned.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the current expression engine</dd>
</dl>
</li>
</ul>
<a name="getMaxIndex-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMaxIndex</h4>
<pre>int&nbsp;getMaxIndex(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key)</pre>
<div class="block">Returns the maximum defined index for the given key. This is useful if
 there are multiple values for this key. They can then be addressed
 separately by specifying indices from 0 to the return value of this
 method.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key to be checked</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the maximum defined index for this key</dd>
</dl>
</li>
</ul>
<a name="getRootElementName--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getRootElementName</h4>
<pre><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;getRootElementName()</pre>
<div class="block">Returns the name of the root element of this configuration. This
 information may be of use in some cases, e.g. for sub configurations
 created using the <code>immutableConfigurationsAt()</code> method. The exact
 meaning of the string returned by this method is specific to a concrete
 implementation. For instance, an XML configuration might return the name
 of the document element.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the name of the root element of this configuration</dd>
</dl>
</li>
</ul>
<a name="immutableConfigurationAt-java.lang.String-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>immutableConfigurationAt</h4>
<pre><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableHierarchicalConfiguration</a>&nbsp;immutableConfigurationAt(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                                                            boolean&nbsp;supportUpdates)</pre>
<div class="block"><p>
 Returns an immutable hierarchical configuration object that wraps the
 configuration node specified by the given key. This method provides an
 easy means of accessing sub trees of a hierarchical configuration. In the
 returned configuration the sub tree can directly be accessed, it becomes
 the root node of this configuration. Because of this the passed in key
 must select exactly one configuration node; otherwise an
 <code>IllegalArgumentException</code> will be thrown.
 </p>
 <p>
 The difference between this method and the
 <a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#immutableSubset-java.lang.String-"><code>ImmutableConfiguration.immutableSubset(String)</code></a> method is that
 <code>immutableSubset()</code> supports arbitrary subsets of configuration nodes
 while <code>immutableConfigurationAt()</code> only returns a single sub tree.
 Please refer to the documentation of the
 <code>SubnodeConfiguration</code> class to obtain further information
 about subnode configurations and when they should be used.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key that selects the sub tree</dd>
<dd><code>supportUpdates</code> - a flag whether the returned subnode configuration
 should be able to handle updates of its parent</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a hierarchical configuration that contains this sub tree</dd>
</dl>
</li>
</ul>
<a name="immutableConfigurationAt-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>immutableConfigurationAt</h4>
<pre><a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableHierarchicalConfiguration</a>&nbsp;immutableConfigurationAt(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key)</pre>
<div class="block">Returns an immutable hierarchical configuration for the node specified by
 the given key. This is a short form for <code>immutableConfigurationAt(key,
 &lt;b&gt;false&lt;/b&gt;)</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key that selects the sub tree</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a hierarchical configuration that contains this sub tree</dd>
</dl>
</li>
</ul>
<a name="immutableConfigurationsAt-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>immutableConfigurationsAt</h4>
<pre><a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableHierarchicalConfiguration</a>&gt;&nbsp;immutableConfigurationsAt(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key)</pre>
<div class="block">Returns a list of immutable configurations for all configuration nodes selected
 by the given key. This method will evaluate the passed in key (using the
 current <code>ExpressionEngine</code>) and then create an immutable subnode
 configuration for each returned node (like
 <a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html#immutableConfigurationAt-java.lang.String-"><code>immutableConfigurationAt(String)</code></a>}). This is especially
 useful when dealing with list-like structures. As an example consider the
 configuration that contains data about database tables and their fields.
 If you need access to all fields of a certain table, you can simply do

 <pre>
 List&lt;ImmutableHierarchicalConfiguration&gt; fields =
   config.immutableConfigurationsAt("tables.table(0).fields.field");
 for(Iterator&lt;ImmutableHierarchicalConfiguration&gt; it = fields.iterator();
   it.hasNext();)
 {
     ImmutableHierarchicalConfiguration sub = it.next();
     // now the children and attributes of the field node can be
     // directly accessed
     String fieldName = sub.getString("name");
     String fieldType = sub.getString("type");
     ...
 </pre></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key for selecting the desired nodes</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a list with immutable hierarchical configuration objects; each
 configuration represents one of the nodes selected by the passed in key</dd>
</dl>
</li>
</ul>
<a name="immutableChildConfigurationsAt-java.lang.String-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>immutableChildConfigurationsAt</h4>
<pre><a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html" title="interface in org.apache.commons.configuration2">ImmutableHierarchicalConfiguration</a>&gt;&nbsp;immutableChildConfigurationsAt(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key)</pre>
<div class="block">Returns a list of immutable configurations for all direct child elements
 of the node selected by the given key. With this method it is possible to
 inspect the content of a hierarchical structure; all children of a given
 node can be queried without having to know their exact names. If the
 passed in key does not point to a single node, an empty list is returned.
 This is also the result if the node referred to by the key does not have
 child elements.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key for selecting the desired parent node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a collection with immutable configurations for all child nodes of
         the selected parent node</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/ImmutableHierarchicalConfiguration.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/apache/commons/configuration2/ImmutableConfiguration.html" title="interface in org.apache.commons.configuration2"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/apache/commons/configuration2/INIConfiguration.html" title="class in org.apache.commons.configuration2"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/apache/commons/configuration2/ImmutableHierarchicalConfiguration.html" target="_top">Frames</a></li>
<li><a href="ImmutableHierarchicalConfiguration.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2017 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
